// Decky Loader will pass this api in, it's versioned to allow for backwards compatibility.
// @ts-ignore

// Prevents it from being duplicated in output.
const manifest = {"name":"Decky Framegen","author":"JSON Derulo","flags":[],"api_version":1,"publish":{"tags":["DLSS","Framegen","upscaling","FSR"],"description":"Allows using FSR for upscaling and frame generation in games with DLSS support. Uses DLSS Enabler Installer for Linux and Steam Deck by FakeMichau.","image":"https://raw.githubusercontent.com/xXJSONDeruloXx/Decky-Framegen/main/assets/decky_framegen.jpeg"}};
const API_VERSION = 2;
const internalAPIConnection = window.__DECKY_SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED_deckyLoaderAPIInit;
// Initialize
if (!internalAPIConnection) {
    throw new Error('[@decky/api]: Failed to connect to the loader as as the loader API was not initialized. This is likely a bug in Decky Loader.');
}
// Version 1 throws on version mismatch so we have to account for that here.
let api;
try {
    api = internalAPIConnection.connect(API_VERSION, manifest.name);
}
catch {
    api = internalAPIConnection.connect(1, manifest.name);
    console.warn(`[@decky/api] Requested API version ${API_VERSION} but the running loader only supports version 1. Some features may not work.`);
}
if (api._version != API_VERSION) {
    console.warn(`[@decky/api] Requested API version ${API_VERSION} but the running loader only supports version ${api._version}. Some features may not work.`);
}
const callable = api.callable;
const definePlugin = (fn) => {
    return (...args) => {
        // TODO: Maybe wrap this
        return fn(...args);
    };
};

var DefaultContext = {
  color: undefined,
  size: undefined,
  className: undefined,
  style: undefined,
  attr: undefined
};
var IconContext = SP_REACT.createContext && /*#__PURE__*/SP_REACT.createContext(DefaultContext);

var _excluded = ["attr", "size", "title"];
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } } return target; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function Tree2Element(tree) {
  return tree && tree.map((node, i) => /*#__PURE__*/SP_REACT.createElement(node.tag, _objectSpread({
    key: i
  }, node.attr), Tree2Element(node.child)));
}
function GenIcon(data) {
  return props => /*#__PURE__*/SP_REACT.createElement(IconBase, _extends({
    attr: _objectSpread({}, data.attr)
  }, props), Tree2Element(data.child));
}
function IconBase(props) {
  var elem = conf => {
    var {
        attr,
        size,
        title
      } = props,
      svgProps = _objectWithoutProperties(props, _excluded);
    var computedSize = size || conf.size || "1em";
    var className;
    if (conf.className) className = conf.className;
    if (props.className) className = (className ? className + " " : "") + props.className;
    return /*#__PURE__*/SP_REACT.createElement("svg", _extends({
      stroke: "currentColor",
      fill: "currentColor",
      strokeWidth: "0"
    }, conf.attr, attr, svgProps, {
      className: className,
      style: _objectSpread(_objectSpread({
        color: props.color || conf.color
      }, conf.style), props.style),
      height: computedSize,
      width: computedSize,
      xmlns: "http://www.w3.org/2000/svg"
    }), title && /*#__PURE__*/SP_REACT.createElement("title", null, title), props.children);
  };
  return IconContext !== undefined ? /*#__PURE__*/SP_REACT.createElement(IconContext.Consumer, null, conf => elem(conf)) : elem(DefaultContext);
}

// THIS FILE IS AUTO GENERATED
function RiAiGenerate (props) {
  return GenIcon({"tag":"svg","attr":{"viewBox":"0 0 24 24","fill":"currentColor"},"child":[{"tag":"path","attr":{"d":"M15 5.25C16.7949 5.25 18.25 3.79493 18.25 2H19.75C19.75 3.79493 21.2051 5.25 23 5.25V6.75C21.2051 6.75 19.75 8.20507 19.75 10H18.25C18.25 8.20507 16.7949 6.75 15 6.75V5.25ZM4 7C4 5.89543 4.89543 5 6 5H13V3H6C3.79086 3 2 4.79086 2 7V17C2 19.2091 3.79086 21 6 21H18C20.2091 21 22 19.2091 22 17V12H20V17C20 18.1046 19.1046 19 18 19H6C4.89543 19 4 18.1046 4 17V7Z"},"child":[]}]})(props);
}

const runInstallFGMod = callable("run_install_fgmod");
const runUninstallFGMod = callable("run_uninstall_fgmod");
const checkFGModPath = callable("check_fgmod_path");
const listInstalledGames = callable("list_installed_games");
const logError = callable("log_error");
function FGModInstallerSection() {
    const [installing, setInstalling] = SP_REACT.useState(false);
    const [uninstalling, setUninstalling] = SP_REACT.useState(false);
    const [installResult, setInstallResult] = SP_REACT.useState(null);
    const [uninstallResult, setUninstallResult] = SP_REACT.useState(null);
    const [pathExists, setPathExists] = SP_REACT.useState(null);
    SP_REACT.useEffect(() => {
        const checkPath = async () => {
            try {
                const result = await checkFGModPath();
                setPathExists(result.exists);
            }
            catch (e) {
                logError('useEffect -> checkPath' + String(e));
                console.error(e);
            }
        };
        checkPath(); // Initial check
        const intervalId = setInterval(checkPath, 3000); // Check every 3 seconds
        return () => clearInterval(intervalId); // Cleanup interval on component unmount
    }, []);
    SP_REACT.useEffect(() => {
        if (installResult) {
            const timer = setTimeout(() => {
                setInstallResult(null);
            }, 5000);
            return () => clearTimeout(timer);
        }
        return () => { }; // Ensure a cleanup function is always returned
    }, [installResult]);
    SP_REACT.useEffect(() => {
        if (uninstallResult) {
            const timer = setTimeout(() => {
                setUninstallResult(null);
            }, 5000);
            return () => clearTimeout(timer);
        }
        return () => { };
    }, [uninstallResult]);
    const handleInstallClick = async () => {
        try {
            setInstalling(true);
            const result = await runInstallFGMod();
            setInstalling(false);
            setInstallResult(result);
        }
        catch (e) {
            logError('handleInstallClick: ' + String(e));
            console.error(e);
        }
    };
    const handleUninstallClick = async () => {
        try {
            setUninstalling(true);
            const result = await runUninstallFGMod();
            setUninstalling(false);
            setUninstallResult(result);
        }
        catch (e) {
            logError('handleUninstallClick' + String(e));
            console.error(e);
        }
    };
    return (window.SP_REACT.createElement(DFL.PanelSection, null,
        pathExists !== null ? (window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement("div", { style: { color: pathExists ? "green" : "red" } }, pathExists ? "Mod Is Installed" : "Mod Not Installed"))) : null,
        pathExists === false ? (window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement(DFL.ButtonItem, { layout: "below", onClick: handleInstallClick, disabled: installing }, installing ? "Installing..." : "Install FG Mod"))) : null,
        pathExists === true ? (window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement(DFL.ButtonItem, { layout: "below", onClick: handleUninstallClick, disabled: uninstalling }, uninstalling ? "Uninstalling..." : "Uninstall FG Mod"))) : null,
        installResult ? (window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement("div", null,
                window.SP_REACT.createElement("strong", null, "Status:"),
                " ",
                installResult.status === "success" ? "Success" : "Error",
                window.SP_REACT.createElement("br", null),
                installResult.output ? (window.SP_REACT.createElement(window.SP_REACT.Fragment, null,
                    window.SP_REACT.createElement("strong", null, "Output:"),
                    window.SP_REACT.createElement("pre", { style: { whiteSpace: "pre-wrap" } }, installResult.output))) : null,
                installResult.message ? (window.SP_REACT.createElement(window.SP_REACT.Fragment, null,
                    window.SP_REACT.createElement("strong", null, "Error:"),
                    " ",
                    installResult.message)) : null))) : null,
        uninstallResult ? (window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement("div", null,
                window.SP_REACT.createElement("strong", null, "Status:"),
                " ",
                uninstallResult.status === "success" ? "Success" : "Error",
                window.SP_REACT.createElement("br", null),
                uninstallResult.output ? (window.SP_REACT.createElement(window.SP_REACT.Fragment, null,
                    window.SP_REACT.createElement("strong", null, "Output:"),
                    window.SP_REACT.createElement("pre", { style: { whiteSpace: "pre-wrap" } }, uninstallResult.output))) : null,
                uninstallResult.message ? (window.SP_REACT.createElement(window.SP_REACT.Fragment, null,
                    window.SP_REACT.createElement("strong", null, "Error:"),
                    " ",
                    uninstallResult.message)) : null))) : null,
        window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement("div", null, "Assign a back button to 'insert' keyboard key to use Optiscaler and enable FG in non FG games."))));
}
function InstalledGamesSection() {
    const [games, setGames] = SP_REACT.useState([]);
    const [selectedGame, setSelectedGame] = SP_REACT.useState(null);
    const [result, setResult] = SP_REACT.useState('');
    SP_REACT.useEffect(() => {
        const fetchGames = async () => {
            try {
                const response = await listInstalledGames();
                if (response.status === "success") {
                    const sortedGames = [...response.games]
                        .map(game => ({
                        ...game,
                        appid: parseInt(game.appid, 10),
                    }))
                        .sort((a, b) => a.name.toLowerCase().localeCompare(b.name.toLowerCase()));
                    setGames(sortedGames);
                }
                else {
                    logError('fetchGames: ' + JSON.stringify(response));
                    console.error('fetchGames: ' + JSON.stringify(response));
                }
            }
            catch (error) {
                logError("Error fetching games:" + String(error));
                console.error("Error fetching games:", String(error));
            }
        };
        fetchGames();
    }, []);
    const handlePatchClick = async () => {
        if (!selectedGame)
            return;
        try {
            await SteamClient.Apps.SetAppLaunchOptions(selectedGame.appid, '~/fgmod/fgmod %COMMAND%');
            setResult(`Launch options set successfully for ${selectedGame.name}. You can now select DLSS in the game's menu to use FSR Upscaling and FrameGen equivalents.`);
        }
        catch (error) {
            logError('handlePatchClick: ' + String(error));
            setResult(error instanceof Error ? `Error setting launch options: ${error.message}` : 'Error setting launch options');
        }
    };
    const handleUnpatchClick = async () => {
        if (!selectedGame)
            return;
        try {
            await SteamClient.Apps.SetAppLaunchOptions(selectedGame.appid, '~/fgmod/fgmod-uninstaller.sh %COMMAND%');
            setResult(`DLSS mods will uninstall on next launch of ${selectedGame.name}. The game is now unpatched.`);
        }
        catch (error) {
            logError('handleUnpatchClick: ' + String(error));
            setResult(error instanceof Error ? `Error clearing launch options: ${error.message}` : 'Error clearing launch options');
        }
    };
    return (window.SP_REACT.createElement(DFL.PanelSection, { title: "Select a game to patch:" },
        window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement(DFL.DropdownItem, { rgOptions: games.map(game => ({
                    data: game.appid,
                    label: game.name
                })), selectedOption: selectedGame?.appid, onChange: (option) => {
                    const game = games.find(g => g.appid === option.data);
                    setSelectedGame(game || null);
                    setResult('');
                }, strDefaultLabel: "Select a game...", menuLabel: "Installed Games" })),
        result ? (window.SP_REACT.createElement(DFL.PanelSectionRow, null,
            window.SP_REACT.createElement("div", { style: {
                    padding: '12px',
                    marginTop: '16px',
                    backgroundColor: 'var(--decky-selected-ui-bg)',
                    borderRadius: '4px'
                } }, result))) : null,
        selectedGame ? (window.SP_REACT.createElement(window.SP_REACT.Fragment, null,
            window.SP_REACT.createElement(DFL.PanelSectionRow, null,
                window.SP_REACT.createElement(DFL.ButtonItem, { layout: "below", onClick: handlePatchClick }, "Patch")),
            window.SP_REACT.createElement(DFL.PanelSectionRow, null,
                window.SP_REACT.createElement(DFL.ButtonItem, { layout: "below", onClick: handleUnpatchClick }, "Unpatch")))) : null));
}
var index = definePlugin(() => ({
    name: "Framegen Plugin",
    titleView: window.SP_REACT.createElement("div", null, "Decky Framegen"),
    alwaysRender: true,
    content: (window.SP_REACT.createElement(window.SP_REACT.Fragment, null,
        window.SP_REACT.createElement(FGModInstallerSection, null),
        window.SP_REACT.createElement(InstalledGamesSection, null))),
    icon: window.SP_REACT.createElement(RiAiGenerate, null),
    onDismount() {
        console.log("Framegen Plugin unmounted");
    },
}));

export { index as default };
//# sourceMappingURL=index.js.map
